/*
 * This program is a java class of MetaMap Norm to perfrom following lvg flows: 
 * -f:g:rs:o:l 
 */

import java.util.*;
import java.io.*;

import gov.nih.nlm.nls.lvg.Lib.*;
import gov.nih.nlm.nls.lvg.Flows.*;
import gov.nih.nlm.nls.lvg.Api.*;

public class MetaMapNorm
{
	public static void main(String[] args)
	{
		if(args.length > 0)
		{
			System.err.println("Usage: java MetaMapNorm");
			System.exit(0);
		}

		String inStr = ":  Padget's Disease(s), nos ";

		// normalize
		// TBU: To be updated
		String lvgConfigFile =
			"/usr/local/Deploy/Projects/LVG/lvg2010/data/config/lvg.properties";
		LvgApi lvgApi = new LvgApi(lvgConfigFile);
		String outStr = MetaMapNorm.Mutate(inStr, lvgApi);
		lvgApi.CleanUp();

		//print out
		System.out.println("-- inStr: [" + inStr + "]");
		System.out.println("-- outStr: [" + outStr + "]");
	}

	public static String Mutate(String inStr, LvgApi lvgApi)
	{
		String outStr = new String();

		try
		{
			// 1. -f:g, remove genitive
			LexItem inLex1 = new LexItem(inStr);
			Vector<LexItem> outs1
				= ToRemoveGenitive.Mutate(inLex1, false, false);
			if(outs1.size() > 1)
			{
				System.err.println("** ERR@ToRemoveGenitive, outs.size():"
					+ outs1.size());
			}

			// 2. -f:rs, remove parenthetic plural forms
			LexItem inLex2 = LexItem.TargetToSource(outs1.elementAt(0));
			Vector<LexItem> outs2
				= ToRemoveS.Mutate(inLex2, lvgApi.GetRemoveSTree(), false, 
				false);
			if(outs2.size() > 1)
			{
				System.err.println("** ERR@ToRemoveS, outs.size():"
					+ outs2.size());
			}

			// 3. -f:o, replace puntuation with space
			LexItem inLex3 = LexItem.TargetToSource(outs2.elementAt(0));
			Vector<LexItem> outs3
				= ToReplacePunctuationWithSpace.Mutate(inLex3, false, false);
			if(outs3.size() > 1)
			{
				System.err.println("** ERR@ToReplacePunctuationWithSpace, outs.size():"
					+ outs3.size());
			}

			// 4. Reconstruct the term by remove duplicated spaces
			LexItem inLex4 = LexItem.TargetToSource(outs3.elementAt(0));
			Vector<LexItem> outs4
				= ToTokenize.Mutate(inLex4, false, false);

			for(int i = 0; i < outs4.size(); i++)
			{
				outStr += outs4.elementAt(i).GetTargetTerm() + " ";
			}
		}
		catch(Exception e)
		{
			System.out.println("***Error: problem of mutate.\n");
		}

		// 5. -f:l, lowercase and trim
		return outStr.trim().toLowerCase();
	}
}
